Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -36,12 +36,16 @@
  */
 
-#include "TLibCommon/TypeDef.h"
+#include "TLibCommon/CommonDef.h"
 #include "TLibCommon/TComRom.h"
 #include "TLibCommon/TComMotionInfo.h"
 #include "TEncSearch.h"
+#include "TLibCommon/TComTU.h"
+#include "TLibCommon/Debug.h"
 #include <math.h>
+#include <limits>
 #if H_3D_INTER_SDC
 #include <memory.h>
 #endif
+
 
 //! \ingroup TLibEncoder
@@ -81,40 +85,63 @@
 };
 
+static Void offsetSubTUCBFs(TComTU &rTu, const ComponentID compID)
+{
+        TComDataCU *pcCU              = rTu.getCU();
+  const UInt        uiTrDepth         = rTu.GetTransformDepthRel();
+  const UInt        uiAbsPartIdx      = rTu.GetAbsPartIdxTU(compID);
+  const UInt        partIdxesPerSubTU = rTu.GetAbsPartIdxNumParts(compID) >> 1;
+
+  //move the CBFs down a level and set the parent CBF
+
+  UChar subTUCBF[2];
+  UChar combinedSubTUCBF = 0;
+
+  for (UInt subTU = 0; subTU < 2; subTU++)
+  {
+    const UInt subTUAbsPartIdx = uiAbsPartIdx + (subTU * partIdxesPerSubTU);
+
+    subTUCBF[subTU]   = pcCU->getCbf(subTUAbsPartIdx, compID, uiTrDepth);
+    combinedSubTUCBF |= subTUCBF[subTU];
+  }
+
+  for (UInt subTU = 0; subTU < 2; subTU++)
+  {
+    const UInt subTUAbsPartIdx = uiAbsPartIdx + (subTU * partIdxesPerSubTU);
+    const UChar compositeCBF = (subTUCBF[subTU] << 1) | combinedSubTUCBF;
+
+    pcCU->setCbfPartRange((compositeCBF << uiTrDepth), compID, subTUAbsPartIdx, partIdxesPerSubTU);
+  }
+}
+
+
 TEncSearch::TEncSearch()
 {
-  m_ppcQTTempCoeffY  = NULL;
-  m_ppcQTTempCoeffCb = NULL;
-  m_ppcQTTempCoeffCr = NULL;
-  m_pcQTTempCoeffY   = NULL;
-  m_pcQTTempCoeffCb  = NULL;
-  m_pcQTTempCoeffCr  = NULL;
+  for (UInt ch=0; ch<MAX_NUM_COMPONENT; ch++)
+  {
+    m_ppcQTTempCoeff[ch]                           = NULL;
+    m_pcQTTempCoeff[ch]                            = NULL;
 #if ADAPTIVE_QP_SELECTION
-  m_ppcQTTempArlCoeffY  = NULL;
-  m_ppcQTTempArlCoeffCb = NULL;
-  m_ppcQTTempArlCoeffCr = NULL;
-  m_pcQTTempArlCoeffY   = NULL;
-  m_pcQTTempArlCoeffCb  = NULL;
-  m_pcQTTempArlCoeffCr  = NULL;
-#endif
-  m_puhQTTempTrIdx   = NULL;
-  m_puhQTTempCbf[0] = m_puhQTTempCbf[1] = m_puhQTTempCbf[2] = NULL;
-  m_pcQTTempTComYuv  = NULL;
-  m_pcEncCfg = NULL;
-  m_pcEntropyCoder = NULL;
-  m_pTempPel = NULL;
-  m_pSharedPredTransformSkip[0] = m_pSharedPredTransformSkip[1] = m_pSharedPredTransformSkip[2] = NULL;
-  m_pcQTTempTUCoeffY   = NULL;
-  m_pcQTTempTUCoeffCb  = NULL;
-  m_pcQTTempTUCoeffCr  = NULL;
+    m_ppcQTTempArlCoeff[ch]                        = NULL;
+    m_pcQTTempArlCoeff[ch]                         = NULL;
+#endif
+    m_puhQTTempCbf[ch]                             = NULL;
+    m_phQTTempCrossComponentPredictionAlpha[ch]    = NULL;
+    m_pSharedPredTransformSkip[ch]                 = NULL;
+    m_pcQTTempTUCoeff[ch]                          = NULL;
 #if ADAPTIVE_QP_SELECTION
-  m_ppcQTTempTUArlCoeffY  = NULL;
-  m_ppcQTTempTUArlCoeffCb = NULL;
-  m_ppcQTTempTUArlCoeffCr = NULL;
-#endif
-  m_puhQTTempTransformSkipFlag[0] = NULL;
-  m_puhQTTempTransformSkipFlag[1] = NULL;
-  m_puhQTTempTransformSkipFlag[2] = NULL;
+    m_ppcQTTempTUArlCoeff[ch]                      = NULL;
+#endif
+    m_puhQTTempTransformSkipFlag[ch]               = NULL;
+  }
+  m_puhQTTempTrIdx                                 = NULL;
+  m_pcQTTempTComYuv                                = NULL;
+  m_pcEncCfg                                       = NULL;
+  m_pcEntropyCoder                                 = NULL;
+  m_pTempPel                                       = NULL;
   setWpScalingDistParam( NULL, -1, REF_PIC_LIST_X );
 }
+
+
+
 
 TEncSearch::~TEncSearch()
@@ -125,64 +152,62 @@
     m_pTempPel = NULL;
   }
-  
+
   if ( m_pcEncCfg )
   {
     const UInt uiNumLayersAllocated = m_pcEncCfg->getQuadtreeTULog2MaxSize()-m_pcEncCfg->getQuadtreeTULog2MinSize()+1;
-    for( UInt ui = 0; ui < uiNumLayersAllocated; ++ui )
-    {
-      delete[] m_ppcQTTempCoeffY[ui];
-      delete[] m_ppcQTTempCoeffCb[ui];
-      delete[] m_ppcQTTempCoeffCr[ui];
+
+    for (UInt ch=0; ch<MAX_NUM_COMPONENT; ch++)
+    {
+      for (UInt layer = 0; layer < uiNumLayersAllocated; layer++)
+      {
+        delete[] m_ppcQTTempCoeff[ch][layer];
 #if ADAPTIVE_QP_SELECTION
-      delete[] m_ppcQTTempArlCoeffY[ui];
-      delete[] m_ppcQTTempArlCoeffCb[ui];
-      delete[] m_ppcQTTempArlCoeffCr[ui];
-#endif
-      m_pcQTTempTComYuv[ui].destroy();
-    }
-  }
-  delete[] m_ppcQTTempCoeffY;
-  delete[] m_ppcQTTempCoeffCb;
-  delete[] m_ppcQTTempCoeffCr;
-  delete[] m_pcQTTempCoeffY;
-  delete[] m_pcQTTempCoeffCb;
-  delete[] m_pcQTTempCoeffCr;
+        delete[] m_ppcQTTempArlCoeff[ch][layer];
+#endif
+      }
+      delete[] m_ppcQTTempCoeff[ch];
+      delete[] m_pcQTTempCoeff[ch];
+      delete[] m_puhQTTempCbf[ch];
 #if ADAPTIVE_QP_SELECTION
-  delete[] m_ppcQTTempArlCoeffY;
-  delete[] m_ppcQTTempArlCoeffCb;
-  delete[] m_ppcQTTempArlCoeffCr;
-  delete[] m_pcQTTempArlCoeffY;
-  delete[] m_pcQTTempArlCoeffCb;
-  delete[] m_pcQTTempArlCoeffCr;
-#endif
+      delete[] m_ppcQTTempArlCoeff[ch];
+      delete[] m_pcQTTempArlCoeff[ch];
+#endif
+    }
+
+    for( UInt layer = 0; layer < uiNumLayersAllocated; layer++ )
+    {
+      m_pcQTTempTComYuv[layer].destroy();
+    }
+  }
+
   delete[] m_puhQTTempTrIdx;
-  delete[] m_puhQTTempCbf[0];
-  delete[] m_puhQTTempCbf[1];
-  delete[] m_puhQTTempCbf[2];
   delete[] m_pcQTTempTComYuv;
-  delete[] m_pSharedPredTransformSkip[0];
-  delete[] m_pSharedPredTransformSkip[1];
-  delete[] m_pSharedPredTransformSkip[2];
-  delete[] m_pcQTTempTUCoeffY;
-  delete[] m_pcQTTempTUCoeffCb;
-  delete[] m_pcQTTempTUCoeffCr;
+
+  for (UInt ch=0; ch<MAX_NUM_COMPONENT; ch++)
+  {
+    delete[] m_pSharedPredTransformSkip[ch];
+    delete[] m_pcQTTempTUCoeff[ch];
 #if ADAPTIVE_QP_SELECTION
-  delete[] m_ppcQTTempTUArlCoeffY;
-  delete[] m_ppcQTTempTUArlCoeffCb;
-  delete[] m_ppcQTTempTUArlCoeffCr;
-#endif
-  delete[] m_puhQTTempTransformSkipFlag[0];
-  delete[] m_puhQTTempTransformSkipFlag[1];
-  delete[] m_puhQTTempTransformSkipFlag[2];
+    delete[] m_ppcQTTempTUArlCoeff[ch];
+#endif
+    delete[] m_phQTTempCrossComponentPredictionAlpha[ch];
+    delete[] m_puhQTTempTransformSkipFlag[ch];
+  }
   m_pcQTTempTransformSkipTComYuv.destroy();
+
   m_tmpYuvPred.destroy();
 }
 
-void TEncSearch::init(TEncCfg*      pcEncCfg,
+
+
+
+Void TEncSearch::init(TEncCfg*      pcEncCfg,
                       TComTrQuant*  pcTrQuant,
                       Int           iSearchRange,
                       Int           bipredSearchRange,
                       Int           iFastSearch,
-                      Int           iMaxDeltaQP,
+                      const UInt    maxCUWidth,
+                      const UInt    maxCUHeight,
+                      const UInt    maxTotalCUDepth,
                       TEncEntropy*  pcEntropyCoder,
                       TComRdCost*   pcRdCost,
@@ -196,26 +221,21 @@
   m_bipredSearchRange    = bipredSearchRange;
   m_iFastSearch          = iFastSearch;
-  m_iMaxDeltaQP          = iMaxDeltaQP;
   m_pcEntropyCoder       = pcEntropyCoder;
   m_pcRdCost             = pcRdCost;
-  
+
   m_pppcRDSbacCoder     = pppcRDSbacCoder;
   m_pcRDGoOnSbacCoder   = pcRDGoOnSbacCoder;
-  
-  for (Int iDir = 0; iDir < 2; iDir++)
-  {
-    for (Int iRefIdx = 0; iRefIdx < 33; iRefIdx++)
+
+  for (UInt iDir = 0; iDir < MAX_NUM_REF_LIST_ADAPT_SR; iDir++)
+  {
+    for (UInt iRefIdx = 0; iRefIdx < MAX_IDX_ADAPT_SR; iRefIdx++)
     {
       m_aaiAdaptSR[iDir][iRefIdx] = iSearchRange;
     }
   }
-  
+
   m_puiDFilter = s_auiDFilter + 4;
-  
+
   // initialize motion cost
-#if !FIX203
-  m_pcRdCost->initRateDistortionModel( m_iSearchRange << 2 );
-#endif
-  
   for( Int iNum = 0; iNum < AMVP_MAX_NUM_CANDS+1; iNum++)
   {
@@ -223,72 +243,58 @@
     {
       if (iIdx < iNum)
+      {
         m_auiMVPIdxCost[iIdx][iNum] = xGetMvpIdxBits(iIdx, iNum);
+      }
       else
+      {
         m_auiMVPIdxCost[iIdx][iNum] = MAX_INT;
-    }
-  }
-  
-  initTempBuff();
-  
-  m_pTempPel = new Pel[g_uiMaxCUWidth*g_uiMaxCUHeight];
-  
+      }
+    }
+  }
+
+  const ChromaFormat cform=pcEncCfg->getChromaFormatIdc();
+  initTempBuff(cform);
+
+  m_pTempPel = new Pel[maxCUWidth*maxCUHeight];
+
   const UInt uiNumLayersToAllocate = pcEncCfg->getQuadtreeTULog2MaxSize()-pcEncCfg->getQuadtreeTULog2MinSize()+1;
-  m_ppcQTTempCoeffY  = new TCoeff*[uiNumLayersToAllocate];
-  m_ppcQTTempCoeffCb = new TCoeff*[uiNumLayersToAllocate];
-  m_ppcQTTempCoeffCr = new TCoeff*[uiNumLayersToAllocate];
-  m_pcQTTempCoeffY   = new TCoeff [g_uiMaxCUWidth*g_uiMaxCUHeight   ];
-  m_pcQTTempCoeffCb  = new TCoeff [g_uiMaxCUWidth*g_uiMaxCUHeight>>2];
-  m_pcQTTempCoeffCr  = new TCoeff [g_uiMaxCUWidth*g_uiMaxCUHeight>>2];
+  const UInt uiNumPartitions = 1<<(maxTotalCUDepth<<1);
+  for (UInt ch=0; ch<MAX_NUM_COMPONENT; ch++)
+  {
+    const UInt csx=::getComponentScaleX(ComponentID(ch), cform);
+    const UInt csy=::getComponentScaleY(ComponentID(ch), cform);
+    m_ppcQTTempCoeff[ch] = new TCoeff* [uiNumLayersToAllocate];
+    m_pcQTTempCoeff[ch]   = new TCoeff [(maxCUWidth*maxCUHeight)>>(csx+csy)   ];
 #if ADAPTIVE_QP_SELECTION
-  m_ppcQTTempArlCoeffY  = new Int*[uiNumLayersToAllocate];
-  m_ppcQTTempArlCoeffCb = new Int*[uiNumLayersToAllocate];
-  m_ppcQTTempArlCoeffCr = new Int*[uiNumLayersToAllocate];
-  m_pcQTTempArlCoeffY   = new Int [g_uiMaxCUWidth*g_uiMaxCUHeight   ];
-  m_pcQTTempArlCoeffCb  = new Int [g_uiMaxCUWidth*g_uiMaxCUHeight>>2];
-  m_pcQTTempArlCoeffCr  = new Int [g_uiMaxCUWidth*g_uiMaxCUHeight>>2];
-#endif
-  
-  const UInt uiNumPartitions = 1<<(g_uiMaxCUDepth<<1);
+    m_ppcQTTempArlCoeff[ch]  = new TCoeff*[uiNumLayersToAllocate];
+    m_pcQTTempArlCoeff[ch]   = new TCoeff [(maxCUWidth*maxCUHeight)>>(csx+csy)   ];
+#endif
+    m_puhQTTempCbf[ch] = new UChar  [uiNumPartitions];
+
+    for (UInt layer = 0; layer < uiNumLayersToAllocate; layer++)
+    {
+      m_ppcQTTempCoeff[ch][layer] = new TCoeff[(maxCUWidth*maxCUHeight)>>(csx+csy)];
+#if ADAPTIVE_QP_SELECTION
+      m_ppcQTTempArlCoeff[ch][layer]  = new TCoeff[(maxCUWidth*maxCUHeight)>>(csx+csy) ];
+#endif
+    }
+
+    m_phQTTempCrossComponentPredictionAlpha[ch]    = new Char  [uiNumPartitions];
+    m_pSharedPredTransformSkip[ch]                 = new Pel   [MAX_CU_SIZE*MAX_CU_SIZE];
+    m_pcQTTempTUCoeff[ch]                          = new TCoeff[MAX_CU_SIZE*MAX_CU_SIZE];
+#if ADAPTIVE_QP_SELECTION
+    m_ppcQTTempTUArlCoeff[ch]                      = new TCoeff[MAX_CU_SIZE*MAX_CU_SIZE];
+#endif
+    m_puhQTTempTransformSkipFlag[ch]               = new UChar [uiNumPartitions];
+  }
   m_puhQTTempTrIdx   = new UChar  [uiNumPartitions];
-  m_puhQTTempCbf[0]  = new UChar  [uiNumPartitions];
-  m_puhQTTempCbf[1]  = new UChar  [uiNumPartitions];
-  m_puhQTTempCbf[2]  = new UChar  [uiNumPartitions];
   m_pcQTTempTComYuv  = new TComYuv[uiNumLayersToAllocate];
   for( UInt ui = 0; ui < uiNumLayersToAllocate; ++ui )
   {
-    m_ppcQTTempCoeffY[ui]  = new TCoeff[g_uiMaxCUWidth*g_uiMaxCUHeight   ];
-    m_ppcQTTempCoeffCb[ui] = new TCoeff[g_uiMaxCUWidth*g_uiMaxCUHeight>>2];
-    m_ppcQTTempCoeffCr[ui] = new TCoeff[g_uiMaxCUWidth*g_uiMaxCUHeight>>2];
-#if ADAPTIVE_QP_SELECTION
-    m_ppcQTTempArlCoeffY[ui]  = new Int[g_uiMaxCUWidth*g_uiMaxCUHeight   ];
-    m_ppcQTTempArlCoeffCb[ui] = new Int[g_uiMaxCUWidth*g_uiMaxCUHeight>>2];
-    m_ppcQTTempArlCoeffCr[ui] = new Int[g_uiMaxCUWidth*g_uiMaxCUHeight>>2];
-#endif
-    m_pcQTTempTComYuv[ui].create( g_uiMaxCUWidth, g_uiMaxCUHeight );
-  }
-  m_pSharedPredTransformSkip[0] = new Pel[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-  m_pSharedPredTransformSkip[1] = new Pel[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-  m_pSharedPredTransformSkip[2] = new Pel[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-  m_pcQTTempTUCoeffY  = new TCoeff[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-  m_pcQTTempTUCoeffCb = new TCoeff[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-  m_pcQTTempTUCoeffCr = new TCoeff[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-#if ADAPTIVE_QP_SELECTION
-  m_ppcQTTempTUArlCoeffY  = new Int[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-  m_ppcQTTempTUArlCoeffCb = new Int[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-  m_ppcQTTempTUArlCoeffCr = new Int[MAX_TS_WIDTH*MAX_TS_HEIGHT];
-#endif
-  m_pcQTTempTransformSkipTComYuv.create( g_uiMaxCUWidth, g_uiMaxCUHeight );
-
-  m_puhQTTempTransformSkipFlag[0] = new UChar  [uiNumPartitions];
-  m_puhQTTempTransformSkipFlag[1] = new UChar  [uiNumPartitions];
-  m_puhQTTempTransformSkipFlag[2] = new UChar  [uiNumPartitions];
-  m_tmpYuvPred.create(MAX_CU_SIZE, MAX_CU_SIZE);
+    m_pcQTTempTComYuv[ui].create( maxCUWidth, maxCUHeight, pcEncCfg->getChromaFormatIdc() );
+  }
+  m_pcQTTempTransformSkipTComYuv.create( maxCUWidth, maxCUHeight, pcEncCfg->getChromaFormatIdc() );
+  m_tmpYuvPred.create(MAX_CU_SIZE, MAX_CU_SIZE, pcEncCfg->getChromaFormatIdc());
 }
-
-#if FASTME_SMOOTHER_MV
-#define FIRSTSEARCHSTOP     1
-#else
-#define FIRSTSEARCHSTOP     0
-#endif
 
 #define TZ_SEARCH_CONFIGURATION                                                                                 \
@@ -299,5 +305,5 @@
 const Bool bTestZeroVectorStop      = 0;                                                                      \
 const Bool bFirstSearchDiamond      = 1;  /* 1 = xTZ8PointDiamondSearch   0 = xTZ8PointSquareSearch */        \
-const Bool bFirstSearchStop         = FIRSTSEARCHSTOP;                                                        \
+const Bool bFirstSearchStop         = m_pcEncCfg->getFastMEAssumingSmootherMVEnabled();                       \
 const UInt uiFirstSearchRounds      = 3;  /* first search stop X rounds after best match (must be >=1) */     \
 const Bool bEnableRasterSearch      = 1;                                                                      \
@@ -311,10 +317,26 @@
 
 
+#define SEL_SEARCH_CONFIGURATION                                                                                 \
+  const Bool bTestOtherPredictedMV    = 1;                                                                       \
+  const Bool bTestZeroVector          = 1;                                                                       \
+  const Bool bEnableRasterSearch      = 1;                                                                       \
+  const Bool bAlwaysRasterSearch      = 0;  /* ===== 1: BETTER but factor 15x slower ===== */                    \
+  const Bool bStarRefinementEnable    = 1;  /* enable either star refinement or raster refinement */             \
+  const Bool bStarRefinementDiamond   = 1;  /* 1 = xTZ8PointDiamondSearch   0 = xTZ8PointSquareSearch */         \
+  const Bool bStarRefinementStop      = 0;                                                                       \
+  const UInt uiStarRefinementRounds   = 2;  /* star refinement stop X rounds after best match (must be >=1) */   \
+  const UInt uiSearchRange            = m_iSearchRange;                                                          \
+  const Int  uiSearchRangeInitial     = m_iSearchRange >> 2;                                                     \
+  const Int  uiSearchStep             = 4;                                                                       \
+  const Int  iMVDistThresh            = 8;                                                                       \
+
+
+
 __inline Void TEncSearch::xTZSearchHelp( TComPattern* pcPatternKey, IntTZSearchStruct& rcStruct, const Int iSearchX, const Int iSearchY, const UChar ucPointNr, const UInt uiDistance )
 {
-  UInt  uiSad;
-  
+  Distortion  uiSad = 0;
+
   Pel*  piRefSrch;
-  
+
   piRefSrch = rcStruct.piRefY + iSearchY * rcStruct.iYStride + iSearchX;
 #if H_3D_IC
@@ -326,33 +348,99 @@
   //-- jclee for using the SAD function pointer
   m_pcRdCost->setDistParam( pcPatternKey, piRefSrch, rcStruct.iYStride,  m_cDistParam );
-  
-  // fast encoder decision: use subsampled SAD when rows > 8 for integer ME
-  if ( m_pcEncCfg->getUseFastEnc() )
-  {
-    if ( m_cDistParam.iRows > 8 )
+
+  if(m_pcEncCfg->getFastSearch() != SELECTIVE)
+  {
+    // fast encoder decision: use subsampled SAD when rows > 8 for integer ME
+    if ( m_pcEncCfg->getUseFastEnc() )
+    {
+      if ( m_cDistParam.iRows > 8 )
+      {
+        m_cDistParam.iSubShift = 1;
+      }
+    }
+  }
+
+  setDistParamComp(COMPONENT_Y);
+
+  // distortion
+  m_cDistParam.bitDepth = pcPatternKey->getBitDepthY();
+  if(m_pcEncCfg->getFastSearch() == SELECTIVE)
+  {
+    Int isubShift = 0;
+    // motion cost
+    Distortion uiBitCost = m_pcRdCost->getCost( iSearchX, iSearchY );
+
+    if ( m_cDistParam.iRows > 32 )
+    {
+      m_cDistParam.iSubShift = 4;
+    }
+    else if ( m_cDistParam.iRows > 16 )
+    {
+      m_cDistParam.iSubShift = 3;
+    }
+    else if ( m_cDistParam.iRows > 8 )
+    {
+      m_cDistParam.iSubShift = 2;
+    }
+    else
     {
       m_cDistParam.iSubShift = 1;
     }
-  }
-
-  setDistParamComp(0);  // Y component
-
-  // distortion
-  m_cDistParam.bitDepth = g_bitDepthY;
-  uiSad = m_cDistParam.DistFunc( &m_cDistParam );
-  
-  // motion cost
-  uiSad += m_pcRdCost->getCost( iSearchX, iSearchY );
-  
-  if( uiSad < rcStruct.uiBestSad )
-  {
-    rcStruct.uiBestSad      = uiSad;
-    rcStruct.iBestX         = iSearchX;
-    rcStruct.iBestY         = iSearchY;
-    rcStruct.uiBestDistance = uiDistance;
-    rcStruct.uiBestRound    = 0;
-    rcStruct.ucPointNr      = ucPointNr;
+
+    Distortion uiTempSad = m_cDistParam.DistFunc( &m_cDistParam );
+    if((uiTempSad + uiBitCost) < rcStruct.uiBestSad)
+    {
+      uiSad += uiTempSad >>  m_cDistParam.iSubShift;
+      while(m_cDistParam.iSubShift > 0)
+      {
+        isubShift         = m_cDistParam.iSubShift -1;
+        m_cDistParam.pOrg = pcPatternKey->getROIY() + (pcPatternKey->getPatternLStride() << isubShift);
+        m_cDistParam.pCur = piRefSrch + (rcStruct.iYStride << isubShift);
+        uiTempSad = m_cDistParam.DistFunc( &m_cDistParam );
+        uiSad += uiTempSad >>  m_cDistParam.iSubShift;
+        if(((uiSad << isubShift) + uiBitCost) > rcStruct.uiBestSad)
+        {
+          break;
+        }
+
+        m_cDistParam.iSubShift--;
+      }
+
+      if(m_cDistParam.iSubShift == 0)
+      {
+        uiSad += uiBitCost;
+        if( uiSad < rcStruct.uiBestSad )
+        {
+          rcStruct.uiBestSad      = uiSad;
+          rcStruct.iBestX         = iSearchX;
+          rcStruct.iBestY         = iSearchY;
+          rcStruct.uiBestDistance = uiDistance;
+          rcStruct.uiBestRound    = 0;
+          rcStruct.ucPointNr      = ucPointNr;
+        }
+      }
+    }
+  }
+  else
+  {
+    uiSad = m_cDistParam.DistFunc( &m_cDistParam );
+
+    // motion cost
+    uiSad += m_pcRdCost->getCost( iSearchX, iSearchY );
+
+    if( uiSad < rcStruct.uiBestSad )
+    {
+      rcStruct.uiBestSad      = uiSad;
+      rcStruct.iBestX         = iSearchX;
+      rcStruct.iBestY         = iSearchY;
+      rcStruct.uiBestDistance = uiDistance;
+      rcStruct.uiBestRound    = 0;
+      rcStruct.ucPointNr      = ucPointNr;
+    }
   }
 }
+
+
+
 
 __inline Void TEncSearch::xTZ2PointSearch( TComPattern* pcPatternKey, IntTZSearchStruct& rcStruct, TComMv* pcMvSrchRngLT, TComMv* pcMvSrchRngRB )
@@ -362,5 +450,5 @@
   Int   iSrchRngVerTop    = pcMvSrchRngLT->getVer();
   Int   iSrchRngVerBottom = pcMvSrchRngRB->getVer();
-  
+
   // 2 point search,                   //   1 2 3
   // check only the 2 untested points  //   4 0 5
@@ -486,4 +574,7 @@
 }
 
+
+
+
 __inline Void TEncSearch::xTZ8PointSquareSearch( TComPattern* pcPatternKey, IntTZSearchStruct& rcStruct, TComMv* pcMvSrchRngLT, TComMv* pcMvSrchRngRB, const Int iStartX, const Int iStartY, const Int iDist )
 {
@@ -492,5 +583,5 @@
   Int   iSrchRngVerTop    = pcMvSrchRngLT->getVer();
   Int   iSrchRngVerBottom = pcMvSrchRngRB->getVer();
-  
+
   // 8 point search,                   //   1 2 3
   // search around the start point     //   4 0 5
@@ -502,5 +593,5 @@
   const Int iRight      = iStartX + iDist;
   rcStruct.uiBestRound += 1;
-  
+
   if ( iTop >= iSrchRngVerTop ) // check top
   {
@@ -511,5 +602,5 @@
     // top middle
     xTZSearchHelp( pcPatternKey, rcStruct, iStartX, iTop, 2, iDist );
-    
+
     if ( iRight <= iSrchRngHorRight ) // check top right
     {
@@ -533,5 +624,5 @@
     // check bottom middle
     xTZSearchHelp( pcPatternKey, rcStruct, iStartX, iBottom, 7, iDist );
-    
+
     if ( iRight <= iSrchRngHorRight ) // check bottom right
     {
@@ -540,4 +631,7 @@
   } // check bottom
 }
+
+
+
 
 __inline Void TEncSearch::xTZ8PointDiamondSearch( TComPattern* pcPatternKey, IntTZSearchStruct& rcStruct, TComMv* pcMvSrchRngLT, TComMv* pcMvSrchRngRB, const Int iStartX, const Int iStartY, const Int iDist )
@@ -547,5 +641,5 @@
   Int   iSrchRngVerTop    = pcMvSrchRngLT->getVer();
   Int   iSrchRngVerBottom = pcMvSrchRngRB->getVer();
-  
+
   // 8 point search,                   //   1 2 3
   // search around the start point     //   4 0 5
@@ -557,5 +651,5 @@
   const Int iRight      = iStartX + iDist;
   rcStruct.uiBestRound += 1;
-  
+
   if ( iDist == 1 ) // iDist == 1
   {
@@ -585,5 +679,5 @@
       const Int iLeft_2     = iStartX - (iDist>>1);
       const Int iRight_2    = iStartX + (iDist>>1);
-      
+
       if (  iTop >= iSrchRngVerTop && iLeft >= iSrchRngHorLeft &&
           iRight <= iSrchRngHorRight && iBottom <= iSrchRngVerBottom ) // check border
@@ -685,5 +779,5 @@
           Int iPosXL = iStartX - ((iDist>>2) * index);
           Int iPosXR = iStartX + ((iDist>>2) * index);
-          
+
           if ( iPosYT >= iSrchRngVerTop ) // check top
           {
@@ -714,28 +808,35 @@
 }
 
+
+
+
+
 //<--
 
-UInt TEncSearch::xPatternRefinement( TComPattern* pcPatternKey,
-                                    TComMv baseRefMv,
-                                    Int iFrac, TComMv& rcMvFrac )
+Distortion TEncSearch::xPatternRefinement( TComPattern* pcPatternKey,
+                                           TComMv baseRefMv,
+                                           Int iFrac, TComMv& rcMvFrac,
+                                           Bool bAllowUseOfHadamard
+                                         )
 {
-  UInt  uiDist;
-  UInt  uiDistBest  = MAX_UINT;
-  UInt  uiDirecBest = 0;
-  
+  Distortion  uiDist;
+  Distortion  uiDistBest  = std::numeric_limits<Distortion>::max();
+  UInt        uiDirecBest = 0;
+
   Pel*  piRefPos;
-  Int iRefStride = m_filteredBlock[0][0].getStride();
-  m_pcRdCost->setDistParam( pcPatternKey, m_filteredBlock[0][0].getLumaAddr(), iRefStride, 1, m_cDistParam, m_pcEncCfg->getUseHADME() );
-  
+  Int iRefStride = m_filteredBlock[0][0].getStride(COMPONENT_Y);
+
+  m_pcRdCost->setDistParam( pcPatternKey, m_filteredBlock[0][0].getAddr(COMPONENT_Y), iRefStride, 1, m_cDistParam, m_pcEncCfg->getUseHADME() && bAllowUseOfHadamard );
+
   const TComMv* pcMvRefine = (iFrac == 2 ? s_acMvRefineH : s_acMvRefineQ);
-  
+
   for (UInt i = 0; i < 9; i++)
   {
     TComMv cMvTest = pcMvRefine[i];
     cMvTest += baseRefMv;
-    
+
     Int horVal = cMvTest.getHor() * iFrac;
     Int verVal = cMvTest.getVer() * iFrac;
-    piRefPos = m_filteredBlock[ verVal & 3 ][ horVal & 3 ].getLumaAddr();
+    piRefPos = m_filteredBlock[ verVal & 3 ][ horVal & 3 ].getAddr(COMPONENT_Y);
     if ( horVal == 2 && ( verVal & 1 ) == 0 )
     {
@@ -749,5 +850,5 @@
     cMvTest += rcMvFrac;
 
-    setDistParamComp(0);  // Y component
+    setDistParamComp(COMPONENT_Y);
 #if H_3D_IC
     m_cDistParam.bUseIC = pcPatternKey->getICFlag();
@@ -756,9 +857,10 @@
     m_cDistParam.bUseSDCMRSAD = pcPatternKey->getSDCMRSADFlag();
 #endif
+
     m_cDistParam.pCur = piRefPos;
-    m_cDistParam.bitDepth = g_bitDepthY;
+    m_cDistParam.bitDepth = pcPatternKey->getBitDepthY();
     uiDist = m_cDistParam.DistFunc( &m_cDistParam );
     uiDist += m_pcRdCost->getCost( cMvTest.getHor(), cMvTest.getVer() );
-    
+
     if ( uiDist < uiDistBest )
     {
